<?php
// unlimit time
@set_time_limit(0);

function CheckAbilityOfInstallation() {
  global $db;
  global $MODULE_FOLDER, $TMP_FOLDER, $HTTP_ROOT_PATH, $SUB_FOLDER, $DOCUMENT_ROOT;
  
	$result['Success'] = 1;
	$result['ErrorMessage'] = TOOLS_PATCH_ERROR;
  
  if ( !nc_installer_check_php_version() ) {
    $result['Success'] = 0;
    // error text
    $result['ErrorMessage'] = str_replace("%CURRENT", phpversion(), str_replace("%NEED", "5.1", TOOLS_PATCH_ERROR_UNCORRECT_PHP_VERSION) );
    // return error
    return $result;
  }

	// check if all files are writeable
	$files = file($TMP_FOLDER."files.txt");

	// add check for module files
	$installed_modules = $db->get_results("SELECT `Keyword` FROM `Module`", ARRAY_A);
	if( !empty($installed_modules) ) {
		foreach ($installed_modules as $module) {
			if (file_exists($MODULE_FOLDER.$module['Keyword'])) {
				$module_files = nc_installer_filelist($TMP_FOLDER."modules/".$module['Keyword']);
				foreach ((array)$module_files AS $module_file) {
					$files[] = $SUB_FOLDER.$HTTP_ROOT_PATH."modules/".$module['Keyword']."/".$module_file;
				}
			}
		}
	}

	foreach ($files AS $file) {
		$file = $DOCUMENT_ROOT.rtrim($file);
		if (file_exists($file)) {
      // file is not writable
			if ( !is_writable($file) && !@chmod($file, 0777) ) {
				$result['ErrorMessage'] = str_replace("%FILE", $file, TOOLS_PATCH_ERROR_SET_FILEPERM_IN_HTTP_ROOT_PATH);
				$result['Success'] = 0;
			}
		}
		else {
		// check dir
			###if(!$dirname) continue;
			$dirname = dirname($file);
			// find the nearest existing parent directory
			while ( !file_exists($dirname) ) {
				$dirname = preg_replace("!/[^/]+$!", "", $dirname);
				if ( $dirname==$DOCUMENT_ROOT.rtrim($HTTP_ROOT_PATH, "/") ) break;
			}
			// directory is not writable
			if ( !is_writable($dirname) && !@chmod($dirname, 0777) ) {
				$result['ErrorMessage'] = str_replace("%DIR", $dirname, TOOLS_PATCH_ERROR_SET_DIRPERM_IN_HTTP_ROOT_PATH);
				$result['Success'] = 0;
			}
		}
	}

return $result;
}


/**
 *     ,      CheckAbilityOfInstallation()
 *
 * @return array result data
 */
function InstallPatch() {
  global $TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $db;
	
	$TMP_FOLDER = str_replace("#", "/", $TMP_FOLDER);

	$result['Success'] = 1;
	$result['ErrorMessage'] = TOOLS_PATCH_ERROR;

	// SystemID
	$SystemID = $db->get_var("SELECT `SystemID` FROM `Settings`");
	
	//   
	$installed_modules = $db->get_col("SELECT `Keyword`
		FROM `Module`
		WHERE `Keyword` IN ('auth', 'captcha', 'calendar', 'banner', 'blog', 'forum', 'linkmanager', 'netshop', 'poll', 'search', 'stats', 'subscriber', 'tagscloud')");
		
	foreach ($installed_modules AS $keyword) {
		// Execute SQL, if any
		if ( file_exists($TMP_FOLDER."modules/".$keyword.".sql") ) {
			ExecSQL($TMP_FOLDER."modules/".$keyword.".sql");
		}

		// Create DIR if not exist
		if ( !file_exists($MODULE_FOLDER.$keyword) ) {
			@mkdir($MODULE_FOLDER.$keyword, 0755);
		}

		// Copy all files to modules folder
		nc_installer_copy_all($TMP_FOLDER."modules/".$keyword, $MODULE_FOLDER.$keyword);

		// include script if necessary
		if ( file_exists($TMP_FOLDER."modules/".$keyword.".inc.php") ) {
			include ($TMP_FOLDER."modules/".$keyword.".inc.php");
		}

		// Remove old files
		if( file_exists($TMP_FOLDER."modules/".$keyword.".remove") ) {
			$files_to_remove = file($TMP_FOLDER."modules/".$keyword.".remove");
			foreach ($files_to_remove AS $file) {
				$file = trim($file, "\r\n/");
				if( @is_dir($ROOT_FOLDER.$file) ) {
					@rmdir($ROOT_FOLDER.$file);
				}
				else {
					@unlink($ROOT_FOLDER.$file);
				}
			}
		}
	}

return $result;
}


function InstallPatchAfterAction() {
  global $Description, $db, $PatchResult, $PatchResultText;
  global $ADMIN_FOLDER, $SUB_FOLDER, $ADMIN_PATH;

	$changelog = nc_patch_changelog();
	if($changelog) {
		if ( !function_exists("AddSystemMessage") ) {
			include ($ADMIN_FOLDER."report/system.inc.php");
		}
		
		// AddSystemMessage(message, title),     *(O_o)*
		###  ($PatchResultText ? $PatchResultText."\r\n" : "") -      ,   
		$sysmess = AddSystemMessage($changelog, $Description ? $Description : TOOLS_PATCH_INSTALLED);

		//     
		if($sysmess) {
			nc_print_status( str_replace("%LINK", ($ADMIN_PATH ? $SUB_FOLDER.$ADMIN_PATH : "/netcat/admin/")."report/system.php?SystemMessageID=".$sysmess, TOOLS_PATCH_INFO_SYSTEM_MESSAGE), "info" );
		}
	}

  return true;
}

function nc_installer_check_php_version () {
  // version must be >= 5.1
  if ( preg_match("/^(\d)\.(\d)/is", phpversion(), $matches) ) {
    if ( intval($matches[1].$matches[2]) >= 51 ) return true;
  }
  // version oldest
  return false;
}

function nc_installer_copy_all($from, $to) {

	$from = str_replace("#", "/", $from);
	$to = str_replace("#", "/", $to);

	$dh = @opendir($from);
	if(!$dh) return false;

	while( ( $file = readdir($dh) )!==false ) {
		if($file=="." || $file=="..") continue;
		if( @is_dir($from."/".$file) ) {
			@mkdir($to."/".$file, 0755);
			nc_installer_copy_all($from."/".$file, $to."/".$file);
		}
		else {
			copy($from."/".$file, $to."/".$file);
		}
	}

	closedir($dh);

  return true;
}


function nc_installer_filelist($dir) {

	$dir = str_replace("#", "/", $dir);
	if (!$level) $start_dir = $dir;

	$ret = array();
	// non-existent dir may be passed
	$dh = @opendir($dir); 

	if (!$dh) return false;

	while ( ($file = readdir($dh))!==false ) {
		if ($file=="." || $file=="..") continue;
		if ( is_dir($dir."/".$file) ) {
			$ret = array_merge( $ret, nc_installer_filelist($dir."/".$file) );
		}
		else {
			$ret[] = preg_replace("!^$start_dir/!", "", $dir."/".$file);
		}
	}

	closedir($dh);
	
  return $ret;
}
?>